/****************************************************************************
 *
 *  MAIN.H
 *
 *
 ****************************************************************************/

#include <windows.h>
#include <commdlg.h>
#include <stdlib.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <time.h>
#include <io.h>
#include <fcntl.h>
#include <commctrl.h>
#include <ctype.h>
#include "resource.h"

typedef    POINTS       MPOINT         ;
#define MAKEMPOINT(l)    (*((MPOINT *)&(l)))

/* Macro to restrict a given value to an upper or lower boundary value */
#define BOUND(x,min,max) ((x) < (min) ? (min) : ((x) > (max) ? (max) : (x)))

/* Macro to swap two values */
#define SWAP(x,y)   ((x)^=(y)^=(x)^=(y))

#define UCHAR_FIX(n) ( 255&(n))
//#define UCHAR_FIX(n) ((n))


/***************** GLOBAL VARIABLES *************************/
BOOL SpinTheMessageLoop(HWND);

#define GetRectW(rc) (rc.right-rc.left+1)
#define GetRectH(rc) (rc.bottom-rc.top+1)
 
#define TRUE  1
#define FALSE  0
typedef int BOOL;
#define GetRandom( min, max ) ((rand() % (int)(((max) + 1) - (min))) + (min))
#define IS_LEAP_YEAR(yr) (!((yr)%400) || (!((yr)%4) && (((yr)%100))) )
#define BOUND(x,min,max) ((x) < (min) ? (min) : ((x) > (max) ? (max) : (x)))

int gQuitMssg;
int gInProgress;

BOOL parsefile(HWND hwnd, FILE *infPtr, char *szInFileName);
HWND hWndProgressBar;
#define PROGRESS_MAX_RANGE 100L
BOOL SpinTheMessageLoop(HWND hWnd);

char *__strnistr(const char *str, const char *pattern, int len);
int __memnchr(const char *str, int ch, int len );
char *__strnchr( char *str, int ch, int len );

int isSQL(const char *inStr, int lastCh);
int strFmtSQL(FILE *infPtr, FILE *outfPtr, int  *inCurCh, long dwChCount, long fLen);
void printSQLkwFreq(FILE *outfPtr);
int getFileSize(FILE *srcFile);
int CheckExe(char *mssg);

/* Buffering globals */

#define READ_BUFF_SIZE 20000
#define MIN_LOOK_AHEAD  (READ_BUFF_SIZE/4)
#define MAX_OFFSET  (READ_BUFF_SIZE-MIN_LOOK_AHEAD)
#define MAX_LOOKAHEAD_XML  700  /* keep here -- stay mindful --this value must be < MIN_LOOK_AHEAD*/


int LoadBuffer(FILE *srcFile);
int LoadTrailerQue(int ch);
int getBytesInBuffer(void);
char g_readBuff[];
int g_CurOffs;
int g_LastByteOffs;
int g_currFileSize;
int g_currFileOffs;


/* Other Globals - options */
int SQL_KeyWord_Color;
int translate_opaque_strings;
int plain_text;